<#if isPolled == true>
/**
 * UART Write String - Polling Example Driver File
 * 
 <#if isTestMode == true>
 * @file uc2.c
 * 
 * @addtogroup uart-write-string-example UART Write String
 <#else>
 * @file uart_example.c
 * 
 * @addtogroup uart-example
 </#if>
 * 
 * @brief This is the generated example implementation for UART Write String in Polled mode
 *
 * @version UART Write String - Polled Example Version 1.0.0
*/
<#elseif isCallback == true>
/**
 * UART Write String - Callback Example Driver File
 * 
 * @file uart_example.c
 * 
 * @addtogroup uart-example
 * 
 * @brief This is the generated example implementation for UART Write String in Callback mode
 *
 * @version UART Write String - Callback Example Version 1.0.0
*/
</#if>
${disclaimer}

<#if isPolled == true>
/* Use Case 2 Polled implementation. Copy this code to your project source, e.g., to main.c  */
<#elseif isCallback == true>
/* Use Case 2 Callback implementation. Copy this code to your project source, e.g., to main.c  */
</#if>
<#if isTestMode == false>
/* ------------------------------------------------------------------
</#if>

<#if isTestMode == true>
#include "../../system/system.h"
#include "uc2.h"
<#else>
#include "mcc_generated_files/system/system.h"
</#if>
#include <string.h>

void UART_WriteString(const char *message);

void UART_WriteString(const char *message)
{
    for(int i = 0; i < (int)strlen(message); i++)
    {
        <#if isPolled == true>
        while(!UART.IsTxReady())
        {
            ;
        };
        </#if>
        (void) UART.Write(message[i]);
    }
}

<#if isTestMode == true>
void UART_Example2(void)
<#else>
void main(void)
</#if>
{
    const char message[] = "Hello World!\r\n";
    SYSTEM_Initialize();
    <#if isAVR == false>
    <#if isCallback == true>
    INTERRUPT_GlobalInterruptEnable();
    <#if isPIC16 == true>
    INTERRUPT_PeripheralInterruptEnable();
    </#if>
    </#if>
    </#if>
    (void) UART_WriteString(message); 

    while(1)
    {
        ;
    }    
}
<#if isTestMode == false>
------------------------------------------------------------------ */
</#if>
/**
 End of File
*/