<#if isPolled == true>
/**
 * UART Mirror Characters - Polled Example Driver File
 * 
 <#if isTestMode == true>
 * @file uc4.c
 * 
 * @addtogroup uart-mirroring-example UART Mirroring
 <#else>
 * @file uart_example.c
 * 
 * @addtogroup uart_example
</#if>
 * 
 * @brief This is the generated example implementation for the UART Mirroring Characters - Polled driver.
 *
 * @version UART Mirror Characters - Polled Example Version 1.0.0
*/
<#elseif isCallback == true>
/**
 * UART Mirror Characters - Callback Example Driver File
 * 
 <#if isTestMode == true>
 * @file uc4.c
 <#else>
 * @file uart-example.c
 </#if>
 * 
 * @addtogroup uart-example
 * 
 * @brief This is the generated example implementation for the UART Mirroring Characters - Callback driver.
 *
 * @version UART Mirror Characters - Callback Example Version 1.0.0
*/
</#if>
${disclaimer}

<#if isPolled == true>
/* Use Case 4 - Polled implementation. Copy this code to your project source, e.g., to main.c  */
<#elseif isCallback == true>
/* Use Case 4 - Callback implementation. Copy this code to your project source, e.g., to main.c  */
</#if>
<#if isTestMode == false>
/* ------------------------------------------------------------------
</#if>
<#if isTestMode == true>
#include "../../system/system.h"
#include "uc4.h"
<#else>
#include "mcc_generated_files/system/system.h"
</#if>
#include <string.h>

void UART_echoCharacters(void);

<#if isErrorHandling == true>
void UART_FramingErrorCallback(void);
void UART_OverrunErrorCallback(void);
<#if isAVR == true>
void UART_ParityErrorCallback(void);
</#if>

void UART_FramingErrorCallback(void)
{
     (void)printf("UART Framing Error Occurred.\r\n");
}

void UART_OverrunErrorCallback(void)
{
     (void)printf("UART Buffer Overrun Error Occurred.\r\n");
}
<#if isAVR == true>
void UART_ParityErrorCallback(void)
{
     (void)printf("UART Parity Error Occurred.\r\n");
}
</#if>
</#if>
<#if isPolled == true>
void UART_echoCharacters(void)
{
    uint8_t serialCOMRxdByte;
    
    if(UART.IsRxReady())
    {
        <#if isErrorHandling == true>
        UART.ErrorGet();
        </#if>
        serialCOMRxdByte = UART.Read();
        if(UART.IsTxReady())
        {
            UART.Write(serialCOMRxdByte);
        }
    }
}
<#else>
void UART_echoCharacters(void)
{
    uint8_t serialCOMRxdByte;  
    serialCOMRxdByte = UART.Read();
    UART.Write(serialCOMRxdByte);     
}
</#if>

<#if isTestMode == true>
void UART_Example4(void)
<#else>
int main(void)
</#if>
{
    SYSTEM_Initialize();
    <#if isErrorHandling == true>
    UART.FramingErrorCallbackRegister(&UART_FramingErrorCallback);
    UART.OverrunErrorCallbackRegister(&UART_OverrunErrorCallback);
    <#if isAVR == true>
    UART.ParityErrorCallbackRegister(&UART_ParityErrorCallback);
    </#if>
    </#if>
    <#if isCallback == true>
    UART.RxCompleteCallbackRegister(&UART_echoCharacters);
    <#if isAVR == false>
    INTERRUPT_GlobalInterruptEnable();
    <#if isPIC16 == true>
    INTERRUPT_PeripheralInterruptEnable();
    </#if>
    </#if>
    </#if>
    (void) printf("Hello World!\r\n");
    (void) printf("Type characters in the terminal, to have them echoed back ...\r\n");
    
    while(1)
    {
        <#if isPolled == true>
        UART_echoCharacters();
        <#else>
        ;
        </#if>
    }
}
<#if isTestMode == false>
------------------------------------------------------------------ */
</#if>
/**
 End of File
*/
